unit ClassDef;
interface
uses Windows,Classes,DXDRAWS,DXSOUNDs,Graphics,JPEG,types,dxmenu,dxinput,Others,IngameC,MapList,IniFiles,sysutils,forms;


type


   TGAME=class
           Draw:TDXDraw;
           Sound:TDXSound;
	   Input:TDXInput;
           Data:TData;

           Owner:TObject;
           Menu:TDxMenu;
           Cur:TDXCursor;
	   Tool:TDXTool;
	   BackImg:String;
	   FState:TGameState;
           Options:TOptions;
	   Ingame:TIngame;

	  private

	   procedure SetState(St:TGameState);

	  public
	   FPS1:Word;
	   TempI:It;

	   constructor Create(F:TObject);
	   destructor Destroy;override;
	   procedure Loaddata(Data:TLoadData);
	   procedure Timer;
	   procedure Paint;
	   procedure MenuClick;
	   procedure Quit;
	   procedure BeginInGame;
	   procedure EndInGame;
           procedure ReadIni;
           procedure WriteIni;

           procedure Keys(Key:word;Shift:TShiftState);
	   property State:TGameState read FState write SetState;


	 end;


implementation
uses Main;

constructor TGame.Create(F:TObject);
begin
inherited Create;
ShowCursor(false);
Owner:=(F);
Draw:=TF(F).DXDRaw;
Sound:=TF(F).DXSound;
Input:=TF(F).DXInput;

Data.NGImages:=tf(F).NGImages;
Data.ComImages:=tf(F).CommonImages;
Data.MenuList:=tf(F).Menulist;
Data.ComWaves:=tf(F).CommonWaves;
Data.Comtexts:=tf(F).CommonTexts;
Data.IgImages:=tf(F).IGImages;
Data.MapList:=tf(F).MapList;
Data.Agents:=tf(F).AgentFrames;
data.faces:=tf(f).faces;
Data.Guns:=TF(F).GEImages;
Data.IGSounds:=TF(F).IGSounds;
Data.base:=TF(F).Base;


Loaddata(ldCommon);
Loaddata(ldmainMenu);
Options:=Opt;
ReadIni;
Data.NGImages.Items.MakeColorTable;
Draw.ColorTable := Data.ngImages.Items.ColorTable;
Draw.DefColorTable := Data.ngImages.Items.ColorTable;
Draw.UpdatePalette;

Menu:=TDXMenu.Create(Self,Draw,Sound,Data);
Cur:=TDXCursor.Create(Self);
Tool:=TDXTool.Create(Self,Rect(0,0,0,0));
Menu.Active:=true;
State:=gsMainMenu;
end;

destructor TGame.Destroy;
begin
//Tool.Destroy;
Cur.free;
Menu.free;
Draw:=nil;
Sound:=nil;
Input:=nil;
ShowCursor(true);
inherited Destroy;
end;

procedure TGame.LoadData(Data:TLoadData);
 begin
  with Self.Data do begin
  case Data of
   ldCommon:begin
	     ComImages.Items.LoadFromFile('data\com.dgr');
	     MenuList.Items.LoadFromFile('data\menudef.dmn');
	     Comwaves.Items.LoadFromFile('data\com.dsn');
	     ComTexts.Items.LoadFromFile('data\com.dtx');


	    end;
   ldMainMenu:begin
	     IGImages.Items.Clear;
             Agents.Items.Clear;
	     MapList.Items.Clear;
             Base.items.Clear;
             Guns.Items.Clear;
             Faces.Items.Clear;
	     NGImages.Items.LoadFromFile('data\ng.dgr');
	    end;
   ldInGame:begin
	     NgImages.Items.Clear;
	     IGImages.Items.LoadFromFile('data\ig.dgr');
             Agents.Items.LoadFromFile('data\agents.dgr');
             Base.Items.LoadFromFile('data\base.dgr');
             Guns.Items.LoadFromFile('data\guns.dgr');
             Faces.items.loadfromfile('data\faces.dgr');
             IGsounds.items.loadfromfile('data\ig.dsn');
             MapList.Items.LoadFromFile('data\maps.dma');

	    end;


  end;
  end;
 end;

procedure TGame.SetState(St:TGameState);
begin
 FState:=ST;
 case ST of
 gsMainMenu:begin

	     Menu.load(data.menulist.items.find('main').menu);
	     Menu.Active:=true;
	    end;
 gsLoadGame:begin

	     Menu.load(data.menulist.items.find('loadgame').menu);
	     Menu.Active:=true;
	     Draw.Surface.FillRectAdd(Scr,rgb(0,55,55));
	     Tool.free;
	     tool:=tdxbkg.Create(Self,Rect(0,0,640,480));

	  end;
 gsInfo:  begin
	     Tool.free;
	     Tool:=TDXTable.Create(Self,Rect(240,0,400,480));
	     tdxtable(tool).loadtable(ltInfo);

	     Menu.load(data.menulist.items.find('info').menu);
	     Menu.Active:=true;

	    end;
  gsNewGame:begin
	      Menu.Load(data.MenuList.items.find('newgame').menu);
	      Menu.Active:=true;
	     Draw.Surface.FillRectAdd(Scr,rgb(0,55,55));
	     Tool.free;
	     tool:=tdxbkg.Create(Self,Rect(0,0,640,480));

	    end;
  gsStory:begin
	    Tool.free;
	    Tool:=TDXTable.Create(Self,Rect(30,50,610,400));
	    tdxtable(tool).loadtable(ltStory);
	    Menu.Load(data.MenuList.items.find('okbut').menu);
	    Menu.buttons[1].Caption:='Dal';
	    Menu.Buttons[1].Top:=430;
	    Menu.Active:=true;

	  end;
  gsloading:begin
       //Tool.Destroy;
       //Tool:=TDXTool.Create(Self,Rect(0,0,0,0));
       //Menu.Active:=false;
       end;
 end;
 Paint;
 end;


procedure TGame.Timer;
begin
 Input.Update;

 if Menu.Active then
  if Menu.Mouse then MenuClick;
 if (Tool is TDXTable)and(tDXTable(Tool).ScrollBar)
  then TDXTable(Tool).Click;
 if state=gsingame then Ingame.Timer;

end;

procedure TGame.Paint;
 begin
  case STate of
   gsMainMenu:begin
	     data.NGImages.Items.Find('menubkg').Draw(Draw.Surface,0,0,0);
	     Menu.Paint;
	     DrawLabel(Draw,10,465,VersionInfo,'Arial',clyellow,8);

	    end;
   gsQuit:;
   gsLoadGame:begin
	       tdxbkg(tool).paint;
	       Menu.Paint;
	      end;
   gsInfo:begin
	   Menu.paint;
	   tdxtable(tool).paint;
	   data.comimages.Items.Find('logo').Draw(Draw.Surface,240+150,380,0);

	  end;
    gsnewGame:begin
	       tdxbkg(tool).paint;
	       menu.paint;
	      end;
    gsStory:begin
	    data.NGImages.Items.Find('storybkg').Draw(Draw.Surface,0,0,0);
	    tdxtable(tool).paint;
	    menu.paint;
	    end;

    gsIngame:Ingame.Paint;
    gsloading:begin DrawBitLabel(Draw,Rect(150,200,490,280),'Nahrvm',Data.ComImages.Items.Find('menu'),FontN,clyellow,24);Draw.Flip;end;


 end;
 if (State<>gsQuit)or(State<>gsloading) then Cur.paint;
end;

procedure TGame.MenuClick;
begin

 case State of
  gsmainmenu:case menu.selected of
               1:State:=gsnewgame;
               2:State:=gsLoadGame;
               3:state:=gsInfo;
               4:tf(Owner).Quit;
	     end;
  gsLoadgame:case menu.selected of
	       {1:Menu.Active:=true;
	       2:State:=gsLoadGame;
	       3:State:=gsInfo;
               }11:State:=gsmainmenu;
		else menu.Active:=true;
	       end;
  gsInfo:  case menu.selected of
	       {1:Menu.Active:=true;
	       2:State:=gsLoadGame;
	       3:State:=gsInfo;
	       }2:State:=gsmainmenu;
	       else menu.Active:=true;
	     end;
  gsnewGame:case  menu.selected of
	       1:State:=gsStory;
	       2:State:=gsLoadGame;
	       3:State:=gsmainmenu;
	       else menu.Active:=true;
	     end;
  gsStory:BeginInGame;
  gsIngame:Ingame.MenuClick;
 end;
end;

procedure tgame.keys(key:word;shift:tshiftstate);
 begin
  if state=gsingame then Ingame.Keys(key,shift);

 end;

procedure TGame.BeginInGame;
var S:TStartPack;
begin

 S.Style:=gsKampan;
 S.LoadID:=0;
 if State=gsStory then S.Style:=gsKampan
  else if State=gsChooseMise then S.Style:=gsMise
   else begin S.Style:=gsLoad;S.LoadID:=Menu.Selected;end;
 state:=gsloading;
 sleep(300);
 Loaddata(ldIngame);

 Ingame:=tingame.create(Self,S);
 State:=gsIngame;
end;

procedure TGame.EndInGame;
begin
 loaddata(ldMainMenu);
 State:=gsmainmenu;
 Ingame.Active:=false;
 Ingame.Free;

end;

procedure Tgame.Quit;
 begin
  State:=gsQuit;
  Draw.Surface.Fill(0);
  DrawBitLabel(Draw,Rect(150,200,490,280),'KONEC HRY',Data.ComImages.Items.Find('menu'),Menu.Font.name,clyellow,24);
  Draw.Flip;
  Sleep(500);
  free;
 end;

procedure Tgame.ReadIni;
var I:TIniFile;
begin
I:=TIniFile.Create('Config.ini');
I.ReadInteger('Settings','MoveSpeed',Options.MoveSpeed[otreal]);
I.ReadInteger('Settings','AnimSpeed',Options.AnimSpeed[otreal]);
I.ReadInteger('Settings','Wave',Options.Wave[otreal]);
I.ReadInteger('Settings','Midi',Options.Midi[otreal]);
I.ReadBool('Settings','Acceleration',Options.Acceleration);
I.ReadBool('Settings','FullScreen',Options.FullScreen);
I.ReadBool('Settings','ShowFrameRate',Options.FPS);

I.Free;
end;

procedure TGame.WriteIni;
var I:TIniFile;
begin
I:=TIniFile.Create(ExtractFileDir(Application.ExeName)+'\Config.ini');
I.WriteInteger('Settings','MoveSpeed',Options.MoveSpeed[otreal]);
I.WriteInteger('Settings','AnimSpeed',Options.AnimSpeed[otreal]);
I.WriteInteger('Settings','Wave',Options.Wave[otreal]);
I.WriteInteger('Settings','Midi',Options.Midi[otreal]);
I.WriteBool('Settings','Acceleration',Options.Acceleration);
I.WriteBool('Settings','FullScreen',Options.FullScreen);
I.WriteBool('Settings','ShowFrameRate',Options.FPS);

I.Free;
end;

end.
