unit DXMenu;

interface
uses Windows,Classes,DXDraws,DXSounds,Graphics,types,menulist,jpeg,sysutils;

type
 TButState=(bsDef,bsMove,bsClick);

 TDXBut=record
         Left,
         Top,
         Width,
         Height:Integer;

         defim,
         moveim,
         clickim:string;
         movesn,
         clicksn:string;
      
         State:TButState;


         Caption,
         Name:string;
         Font:TFont;

         end;

 TDXBut30=array[1..30]of TDXBut;

 TDXMenu=class
          public
           Left,
           Top,
           Width,
           Height:Integer;
           ButCount:Integer;
           Loop:word;
           Image:string;
           Selected:integer;
           Caption:string;
           Active:boolean;
           ID:TMenudef;
           Owner:TObject;
           Draw:TDXDraw;
           Sound:TDxSound;
           ImList:TDXImageList;
           SnList:TDXWaveList;

           Font:TFont;
           Buttons:TDXBut30;

           constructor Create(AOwner:TObject;Dr:TDxDraw;Sn:TDxSound;Da:TData);
           procedure Paint;
           procedure Load(IDi:tmenuD);
           function Mouse:boolean;
           destructor Destroy;override;



          end;



implementation
uses Classdef;


constructor TDXMenu.Create(AOwner:TObject;Dr:TDxDraw;Sn:TDxSound;Da:TData);
var i:word;
 begin
  inherited Create;
  Owner:=AOwner;
  Draw:=Dr;
  Sound:=Sn;
  ImList:=Da.ComImages;
  SnList:=Da.ComWaves;
  Font:=TFont.Create;

  for i:=1 to 30 do
     Buttons[i].Font:=TFont.Create;
  Loop:=0;
 end;

procedure TDXMenu.Paint;
 var i:integer;
     R:TRect;
     Max,Ext:Integer;

 begin
  if Assigned(IMList)then
   begin
    if (Image<>'') then
    ImList.Items.Find(Image).StretchDraw(Draw.Surface,Rect(Left,Top,Left+Width,Top+Height),0);

   Max:=1000;
   for i:=1 to ButCount do
    begin
     case Buttons[i].State of
      bsdef:if Buttons[i].Defim<>'' then
          ImList.Items.Find(buttons[i].defIm).StretchDraw(Draw.Surface,Rect(left+buttons[i].Left,top+buttons[i].Top,left+buttons[i].Left+buttons[i].Width,Top+buttons[i].Top+buttons[i].Height),0);
      bsmove:if Buttons[i].moveim<>'' then
          ImList.Items.Find(buttons[i].moveIm).StretchDraw(Draw.Surface,Rect(left+buttons[i].Left,top+buttons[i].Top,left+buttons[i].Left+buttons[i].Width,Top+buttons[i].Top+buttons[i].Height),0);
      bsClick:if Buttons[i].clickim<>'' then
          ImList.Items.Find(buttons[i].clickIm).StretchDraw(Draw.Surface,Rect(left+buttons[i].Left,top+buttons[i].Top,left+buttons[i].Left+buttons[i].Width,Top+buttons[i].Top+buttons[i].Height),0);
      end;

     with Draw.Surface.Canvas do
      begin
        Font.Assign(Buttons[i].Font);
        Ext:=(Buttons[i].height-Textheight(Buttons[i].Caption))div 2;
        R:=Rect(left+buttons[i].Left,ext+top+buttons[i].Top,left+buttons[i].Left+buttons[i].Width,Top+buttons[i].Top+buttons[i].Height);
        SetBkMode(handle,transparent);
        DrawText(Handle,Pchar(Buttons[i].Caption),strlen(Pchar(Buttons[i].Caption)),R,dt_center );

        Release;
      end;
      if Buttons[i].Top<Max then Max:=Buttons[i].Top;
    end;{for}
      with Draw.Surface.Canvas do
      begin
        Font.Color:=ID.FontColor;
        Font.Size:=ID.FontSize;
        Font.Name:=ID.Fontname;
        Ext:=round((Max-Textheight(Caption))/1.7) ;
        r.top:=top+Ext;
        Ext:=(Width-Textwidth(Caption))div 2;
        r.left:=left+Ext;
        SetBkMode(handle,transparent);
        TextOut(r.left,r.top,Caption);
        Release;
      end;


  end;

 end;

procedure TDXMenu.Load(IDi:TMenuD);
var i:integer;
 begin
  Self.ID:=idi.data;
  with idi do
  begin

  butcount:=data.butcount;


  for i:=1 to ButCount do
    begin
     Buttons[i].Font.Name:=data.buttons[i].FontName;
     Buttons[i].Font.Size:=data.buttons[i].FontSize;
     Buttons[i].Font.Color:=data.buttons[i].FontColor;
     Buttons[i].Left:=data.buttons[i].left;
     Buttons[i].top:=data.buttons[i].top;
     Buttons[i].width:=data.buttons[i].width;
     Buttons[i].height:=data.buttons[i].height;

     Buttons[i].caption:=data.buttons[i].caption;
     Buttons[i].name:=data.buttons[i].name;

     Buttons[i].defim:=data.buttons[i].defim;
     Buttons[i].moveim:=data.buttons[i].moveim;
     Buttons[i].clickim:=data.buttons[i].clickim;
     Buttons[i].movesn:=data.buttons[i].movesn;
     Buttons[i].clicksn:=data.buttons[i].clicksn;

    end;
  Font.Name:=data.FontName;
  Font.Size:=data.FontSize;
  Font.Color:=data.FontColor;
  Left:=data.Left;
  Top:=data.Top;
  Width:=data.Width;
  Height:=data.Height;
  Image:=data.Image;
  Caption:=data.caption;

  end;
 end;

function TDXMenu.Mouse:boolean;
var i:it;
    R:TRect;
    P:TPoint;
 begin
  Result:=false;
  if Loop=0 then
  begin
  GetCursorPos(p);
   for i:=1 to ButCount do
   begin

    R:=Rect(Left+Buttons[i].Left,Top+Buttons[i].top,left+Buttons[i].Left+Buttons[i].width,top+Buttons[i].top+buttons[i].height);
    if PtInRect(R,p) then
     begin
      if GetKeyState(vk_lbutton)<0 then
        begin Buttons[i].State:=bsClick;
        Selected:=i;Inc(Loop,TGame(Owner).FPS1);end else
      Buttons[i].State:=bsMove
     end

     else Buttons[i].State:=bsdef;


     end
   end
   else if Loop<300 then Inc(Loop,tgame(Owner).FPS1)
    else begin result:=true;Active:=false;Loop:=0;end;

 
end;

destructor TDXMenu.Destroy;
 var i:integer;
 begin
 Font.Free;
 Draw:=nil;
 Sound:=nil;
 Owner:=nil;
 for i:=1 to 30 do
  buttons[i].font.free;

 inherited Destroy;
 end;

end.
