unit Engine;
interface
uses DxDraws,DXSounds,DXInput,Windows,Graphics,maplist,types,classes,dxclass,mxarrays;

const MaxActors=4096;

type

 TEngine=class;

  TActor=class
          X,Y:integer;
          Right,Bottom:Integer;
          Width,Height:integer;
          AID:integer;
         private
          FEngine:TEngine;
         protected
          procedure DoDraw;virtual;
          procedure DoMove;virtual;
          procedure DoCollision(Spr:TActor);virtual;
         public
          constructor Create(Engine:TEngine);
          destructor Destroy;override;

          procedure Draw;
          procedure Move;
          procedure Collision(Spr:TActor);

         end;



    TBackGround=class(TActor)

                protected
                  procedure DoDraw;override;
                public
                  constructor Create(Engine:TEngine;Rec:TRect);
                  destructor Destroy;override;
                  procedure DrawUp;

                end;

    TActorSprite=class(TActor)
                Image:TPictureCollectionItem;
                function ColTest(out Col:TActor):boolean;

                end;

    TDecor=class(TActorSprite)
            Pos:TPoint;
            FID:integer;
            FHP,
            MaxHP:integer;
            Frames,
            ActFrame:integer;
            Counter:integer;
            Live:boolean;
            Dying:boolean;
           protected
             procedure DoDraw;override;
           private
             procedure SetID(Value:integer);
             procedure SetHP(Value:integer);
           public
             constructor Create(Engine:TEngine);
             property HP:integer read FHP write SetHP;
             property ID:Integer read FID write SetID;

           end;

    TMover=class(TDecor)
            FOrient:TOrient;
            Moving:boolean;
            Gun:TArm;
            Armor:TArmor;
           private
            procedure SetOrient(Value:TOrient);
           protected
            procedure DoFire;virtual;
           public
            function TestMove(Orient:TOrient):boolean;
            procedure Fire;
            property Orient:TOrient read FOrient write SetOrient;

           end;

    TEnemy=class(TMover)

           protected
            procedure DoMove;override;

           end;

    TPlayer=class(TMover)
            Have:TboolArms;
            protected
             procedure DoDraw;override;
             procedure DoMove;override;
            end;


    TBounce=class(TActorSprite)
             ID:integer;
             O:TOrient;
             P:TPoint;
             Owner:TMover;
              ActFrame,
              Frames,
              Counter:integer;
              Live,
              NoFly:boolean;
            protected
             procedure DoDraw;override;
             procedure DoMove;override;
             procedure DoCollision(Spr:TActor);override;
            public
             procedure Explode;
            end;


    TActArray=array[0..MaxActors-1]of TActor;


    TEngine=class
             FAllCount:Integer;

             FActors:TActArray;
             Owner:TObject;

             Base:TDXImageList;
             Agents:TDXImageList;
             Guns:TDXImageList;
             BaseL:TLayer;
             Walk:TboolLayer;

             Players:byte;
             APl:byte;

             MoveSpeed:integer;
             AnimSpeed:integer;
             FPS1:integer;

             Draw:TDXDraw;
             Input:TDXInput;
             Sound:TDXSound;
            private
             function GetCount:integer;
             function Getmax:integer;
            public
              constructor Create(AOwner:TObject);
              destructor Destroy;override;

              procedure DrawView;
              procedure MoveActors;
              function GetActor(Index:integer):TActor;
              procedure Delete(A:TActor);

              property AllCount:Integer read GetCount;
              property Actors:TActArray read FActors write FActors;
              property MaxActor:Integer read GetMax;

            end;


implementation
uses Main,ClassDef,IngameC;

///// TENGINE METHODS ////////////////////////////
constructor TEngine.Create(AOwner:TObject);
 begin
  inherited create;
  Owner:=AOwner;
  FAllCount:=0;
 // FActors:=TBaseArray.Create(MaxActors-1,SizeOf(TActor));
  Base:=TinGame(Owner).Data.Base;
  Guns:=TIngame(Owner).Data.Guns;
  Draw:=TinGame(Owner).Draw;
  Input:=TinGame(Owner).Input;
  Sound:=TinGame(Owner).Sound;
  BaseL:=TIngame(Owner).Mise.Map.Base;
  Walk:=TIngame(Owner).Mise.Map.Walk;
  Agents:=tingame(owner).data.Agents;

  AnimSpeed:=150;
  MoveSpeed:=4;
 end;

destructor TEngine.Destroy;
 var i:it;
 begin
  Owner:=nil;
  Base:=nil;
  Draw:=nil;
  Input:=nil;
  Sound:=nil;
  for i:=0 to Allcount-1 do
    Actors[i].Free;
  inherited Destroy;

 end;

procedure TEngine.DrawView;
 var i:it;

 begin
  FPS1:=TGame(TInGame(Owner).Owner).FPS1;
  if AllCount>0 then
   for i:=0 to Allcount-1 do
   begin
   if Actors[i]<>nil then Actors[i].Draw;
   end;
  if Actors[0] is TBackGround then TBackGround(Actors[0]).DrawUp;
 end;

procedure TEngine.MoveActors;
 var i:it;
      begin
  if AllCount>0 then
   for i:=0 to allcount-1 do
   begin
   if Actors[i]<>nil then Actors[i].Move;
   end;

 end;

function TEngine.GetActor(Index:integer):TActor;
 begin
  Result:=Actors[Index];
//  Actors.GetItem(Index,Result);
 end;

procedure TEngine.Delete(A:TActor);
var Temp:TActArray;
 i,u:integer;
var changed:boolean;
 begin
  Temp:=Actors;
  Changed:=false;
  
  for i:=0 to Allcount-1 do
  begin
  if (not changed)and(Actors[i].AID=A.AID)
   then Changed:=true;
  if not changed then u:=i else u:=i+1;

   if temp[u]<>nil then FActors[i]:=Temp[u];
  end;

  dec(fallcount);
 end;

function TEngine.GetCount:integer;
 begin
   result:=fallcount;
 end;

function TEngine.GetMax:integer;
 begin
  Result:=allCount-1;
 end;
 //////////// TACTOR METHODS   /////////////////////////
constructor TActor.Create(Engine:TEngine);
 begin
  inherited Create;
  FEngine:=Engine;
  inc(fengine.fallcount);
  AID:=FEngine.Allcount-1;
  FEngine.FActors[AID]:=Self;
 end;

destructor TActor.Destroy;  // nevolat -fuckabluje to!
 begin
 // FEngine.FActors.Delete(AID);
  FEngine:=nil;
  inherited Destroy;
 end;

procedure TActor.DoDraw;
 begin
 end;

procedure TActor.DoMove;
 begin
 end;

procedure TActor.Draw;
 begin
  DoDraw;
 end;

procedure TActor.Move;
 begin
  DoMove;
 end;

procedure TActor.DoCollision(Spr:TActor);
 begin

 end;

procedure TActor.Collision(Spr:TActor);
 begin
  DoCollision(Spr);
 end;

////////////// TACTORSPRITE METHODS //////////////////
function TActorSprite.ColTest(out Col:TActor):boolean;
var i:integer;
    AX,AY:integer;
    AR,SR,BR:TREct;
 begin
 Result:=false;
 Col:=nil;
 with FEngine do
 begin
  for i:=0 to allcount-1 do
   begin
    if GetActor(i)is TBounce then begin AX:=TBounce(GetActor(i)).x;Ay:=TBounce(GetActor(i)).y;end
    else begin AX:=TDecor(GetActor(i)).pos.x*tile;AY:=TDecor(GetActor(i)).pos.y*tile;end;
    BR:=REct(TPlayer(GetActor(1)).Pos.X*Tile-600,TPlayer(GetActor(1)).Pos.Y*Tile-600,TPlayer(GetActor(1)).Pos.X*Tile+600,TPlayer(GetActor(1)).Pos.y*Tile+600);
    if not PtInRect(BR,Point(AX,AY)) then Continue;



    if not(GetActor(i)is (TBounce)) then
       AR:=Rect(TDecor(GetActor(i)).Pos.X*Tile+TDecor(GetActor(i)).X,TDecor(GetActor(i)).Pos.y*Tile+TDecor(GetActor(i)).y,TDecor(GetActor(i)).Pos.X*Tile+TDecor(GetActor(i)).X+64,TDecor(GetActor(i)).Pos.y*Tile+TDecor(GetActor(i)).y+64);
     {else if (TBounce(GetActor(i)).Live)and (not TBounce(GetActor(i)).NoFly) then
      AR:=Rect(TBounce(GetActor(i)).X,TBounce(GetActor(i)).Y,TBounce(GetActor(i)).X+32,TBounce(GetActor(i)).Y+32)
      else AR:=Rect(TBounce(GetActor(i)).X,TBounce(GetActor(i)).Y,TBounce(GetActor(i)).X-16+64,TBounce(GetActor(i)).Y-16+64);
      }

      if Self is TBounce then
       begin
         if (TBounce(Self).Live)and not TBounce(Self).NoFly then
      SR:=Rect(TBounce(Self).X,TBounce(Self).Y,TBounce(Self).X+32,TBounce(Self).Y+32)
      else SR:=Rect(TBounce(Self).X,TBounce(Self).Y,TBounce(Self).X+64,TBounce(Self).Y+64);
       end
      else SR:=REct(TDecor(Self).Pos.X*Tile+TDecor(Self).X,TDecor(Self).Pos.y*Tile+TDecor(Self).y,TDecor(Self).Pos.X*Tile+TDecor(Self).X+tile,TDecor(Self).Pos.y*Tile+TDecor(Self).y+tile);

     if OverlapRect(SR,AR) then begin Result:=true;Col:=GetActor(i);end;

   end;

  end;

 end;
 /////////       TBACKGROUND METHODS /////////////////

constructor TBackGround.Create(Engine:TEngine;Rec:TRect);
 begin
  inherited Create(Engine);
  X:=Rec.Left;
  Y:=Rec.Top;
  Right:=Rec.Right;
  Bottom:=Rec.Bottom;
  Width:=Right-X;
  Height:=Bottom-Y;
 end;

destructor TBackGround.Destroy;
 begin

  inherited Destroy;
 end;

procedure TBackground.DoDraw;
var lx,ly:it;
 begin
  with FEngine do
   begin
    for lx:=-1 to VIewWidth+1 do
     for ly:=-1 to ViewHeight+1 do
      begin
       Base.Items[BaseL[TPlayer(getActor(1)).Pos.X+lx-ViewWidth div 2,
                  TPlayer(GetActor(1)).Pos.y+ly-ViewHeight div 2]]
            .Draw(Draw.Surface,lx*Tile-TPlayer(GetActor(1)).X,ly*Tile-TPlayer(GetActor(1)).y,0);
      end;

   end;
 end;

procedure TBackGround.DrawUp;
var lx,ly:it;
 begin
   with FEngine do
   begin
    for lx:=-2 to VIewWidth+2 do
     for ly:=-2 to ViewHeight+2 do
      begin
       if BaseL[TPlayer(GetActor(1)).Pos.X+lx-ViewWidth div 2,
                  TPlayer(GetActor(1)).Pos.y+ly-ViewHeight div 2]>=100
           then Base.Items[99].Draw(Draw.Surface,lx*Tile-TPlayer(GetActor(1)).X,(ly-1)*Tile-TPlayer(GetActor(1)).y,0);

      end;

   end;


 end;
 ///////////////   TDECOR  METHODS ********************
constructor TDecor.Create(Engine:TEngine);
 begin
  inherited Create(Engine);
  Counter:=0;
  Live:=true;
  Dying:=false;
 end;

procedure TDecor.DoDraw;
 var DrawX,DrawY:it;
 begin
  if Image=nil then Exit;
  if (Pos.X<tplayer(FEngine.GetActor(1)).Pos.x-ViewWidth div 2-2)
     or (Pos.X>tplayer(FEngine.GetActor(1)).Pos.x+ViewWidth div 2+2)
     or(Pos.y<tplayer(FEngine.GetActor(1)).Pos.y-Viewheight div 2-2)
     or(Pos.y>tplayer(FEngine.GetActor(1)).Pos.y+ViewHeight div 2+2)
   then exit;

  Frames:=Image.Picture.Graphic.Width div Image.PatternWidth;
  DrawX:=(pos.x-tplayer(FEngine.GetActor(1)).Pos.X+Viewwidth div 2)*Tile+Self.X-TPlayer(FEngine.GetActor(1)).X;
  DrawY:=(pos.y-tplayer(FEngine.GetActor(1)).Pos.y+Viewheight div 2)*Tile+Self.y-TPlayer(FEngine.GetActor(1)).y;


  if Counter<0 then counter:=0;
  if Counter<(FEngine.AnimSpeed)
   then Inc(Counter,FEngine.FPS1)
    else
      begin
       Counter:=0;
       if ActFrame<Frames-1 then
         Inc(ActFrame)
        else
         begin
         ActFrame:=0;
         if (not Live)and(not Dying) then Dying:=true;
         end;
      end;

  if (not Live)and(dying) then FEngine.Delete(Self);
  Image.Draw(FEngine.Draw.Surface,DrawX,DrawY,ActFrame);
 end;


procedure TDecor.SetHP(Value:integer);
 begin

  if (Live)and(not Dying) then
  begin
  FHP:=Value;
  if FHP<1 then begin Live:=false;
   Image:=FEngine.Agents.Items[id+4];Counter:=0;ActFrame:=0;
  end;
  end;

 end;

procedure TDecor.SetID(Value:integer);
 begin
  fid:=value;

  TMover(Self).Orient:=J;

 { case Value of



  end;  }
 end;





 ///////////////// TBOUNCE         METHODS    **************
procedure TBounce.DoMove;
 var Sp:integer;

 function TestMove:boolean;
  var BR:TRect;
      XX,YY:integer;
      WRS:array[1..8]of TRect;
      Pos:TPoint;
      i:integer;
  begin
  result:=true;
  XX:=X;YY:=Y;
  case O of
   S:YY:=Y-FEngine.MoveSpeed*Sp;
   J:YY:=Y+FEngine.MoveSpeed*Sp;
   Z:XX:=X-FEngine.MoveSpeed*Sp;
   V:XX:=X+FEngine.MoveSpeed*Sp;
   SV:begin YY:=Y-FEngine.MoveSpeed*Sp;XX:=X+FEngine.MoveSpeed*Sp;end;
   SZ:begin YY:=Y-FEngine.MoveSpeed*Sp;XX:=X-FEngine.MoveSpeed*Sp;end;
   JV:begin YY:=Y+FEngine.MoveSpeed*Sp;XX:=X+FEngine.MoveSpeed*Sp;end;
   JZ:begin YY:=Y+FEngine.MoveSpeed*Sp;XX:=X-FEngine.MoveSpeed*Sp;end;
  end;
  BR:=Rect(XX-10,YY+20,XX+32-10,YY+32+20);

  pos.x:=(XX div Tile);pos.y:=(YY div Tile);

 if  FEngine.BaseL[pos.x-1,pos.y-1]>=100 then WRS[1]:=Rect((pos.x-1)*Tile,(pos.y-1)*tile,pos.x*tile,pos.y*tile)
          else WRS[1]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x,pos.y-1]>=100 then WRS[2]:=Rect((pos.x)*Tile,(pos.y-1)*tile,(pos.x+1)*tile,pos.y*tile)
          else WRS[2]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y-1]>=100 then WRS[3]:=Rect((pos.x+1)*Tile,(pos.y-1)*tile,(pos.x+2)*tile,pos.y*tile)
          else WRS[3]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x-1,pos.y]>=100 then WRS[4]:=Rect((pos.x-1)*Tile,(pos.y)*tile,pos.x*tile,(pos.y+1)*tile)
          else WRS[4]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y]>=100 then WRS[5]:=Rect((pos.x+1)*Tile,(pos.y)*tile,(pos.x+2)*tile,(pos.y+1)*tile)
          else WRS[5]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x-1,pos.y+1]>=100 then WRS[6]:=Rect((pos.x-1)*Tile,(pos.y+1)*tile,pos.x*tile,(pos.y+2)*tile)
          else WRS[6]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x,pos.y+1]>=100 then WRS[7]:=Rect((pos.x)*Tile,(pos.y+1)*tile,(pos.x+1)*tile,(pos.y+2)*tile)
          else WRS[7]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y+1]>=100 then WRS[8]:=Rect((pos.x+1)*Tile,(pos.y+1)*tile,(pos.x+2)*tile,(pos.y+2)*tile)
          else WRS[8]:=Rect(0,0,0,0);


 for i:=1 to 8 do
  begin
    if overlaprect(br,wrs[i]) then result:=false;
  end;

  end;


 var AC:TActor;
 begin
  if nofly then Exit;
  Sp:=Guns[id].BSpeed;
  if TestMove then
  begin
  case O of
  S:Y:=Y-FEngine.MoveSpeed*Sp;
  J:Y:=Y+FEngine.MoveSpeed*Sp;
  Z:X:=X-FEngine.MoveSpeed*Sp;
  V:X:=X+FEngine.MoveSpeed*Sp;
  SV:begin Y:=Y-FEngine.MoveSpeed*Sp;X:=X+FEngine.MoveSpeed*Sp;end;
  SZ:begin Y:=Y-FEngine.MoveSpeed*Sp;X:=X-FEngine.MoveSpeed*Sp;end;
  JV:begin Y:=Y+FEngine.MoveSpeed*Sp;X:=X+FEngine.MoveSpeed*Sp;end;
  JZ:begin Y:=Y+FEngine.MoveSpeed*Sp;X:=X-FEngine.MoveSpeed*Sp;end;
  end;

  if ColTest(AC)then begin Collision(AC);end;
  end
  else
   Explode;


  if (X -TPlayer(FEngine.GetActor(1)).Pos.x*Tile<-10*Tile)or
      (X -TPlayer(FEngine.GetActor(1)).Pos.x*tile>10*tile)or
     (Y -TPlayer(FEngine.GetActor(1)).Pos.Y*tile<-10*tile)or
     (Y- TPlayer(FEngine.GetActor(1)).Pos.Y*tile>10*tile)then
          FEngine.Delete(Self);

 end;

procedure TBounce.DoDraw;
var DrawX,DrawY:integer;
 begin
  with FEngine do
  BEGIN
  DrawX:=X-(tplayer(FEngine.GetActor(1)).Pos.X-Viewwidth div 2)*tile-tplayer(FEngine.GetActor(1)).X;
  DrawY:=Y-(tplayer(FEngine.GetActor(1)).Pos.Y-Viewheight div 2)*tile-tplayer(FEngine.GetActor(1)).Y;
  if not NoFly then
  Begin
  case O of
  S:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,0);
  SV:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,35);
  V:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,65);
  JV:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,102);
  J:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,127);
  JZ:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,154);
  Z:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,193);
  SZ:Image.DrawRotate(Draw.Surface,DrawX,DrawY,Image.Width,Image.Height,0,0,0,230);
  end;
  End
   else
    Begin
      Frames:=Image.Picture.Graphic.Width div Image.PatternWidth;

  DrawX:=X-(tplayer(FEngine.GetActor(1)).Pos.X-Viewwidth div 2)*tile-tplayer(FEngine.GetActor(1)).X-16;
  DrawY:=Y-(tplayer(FEngine.GetActor(1)).Pos.Y-Viewheight div 2)*tile-tplayer(FEngine.GetActor(1)).Y-16;

  if counter<0 then counter:=0;
  if Counter<FEngine.AnimSpeed
   then Inc(Counter,FEngine.FPS1)
    else
      begin
       Counter:=0;
       if ActFrame<Frames-1 then
         Inc(ActFrame)
        else Live:=false;
      end;
  Image.Draw(FEngine.Draw.Surface,DrawX,DrawY,ActFrame);

    End;
  END;
  if (not Live)and NoFly then FEngine.delete(Self);
 end;

procedure TBounce.Explode;
 begin

  Image:=FEngine.Guns.Items[MaxGuns*2+1];
  NoFly:=true;
  Live:=true;
 end;

procedure TBounce.DoCollision(Spr:TActor);
 begin
  if (Spr.AID<>Owner.AID)and(not(Spr is TBounce))

   then
  begin
  TDecor(Spr).HP:=TDecor(Spr).hp-guns[id].power;
  Explode;
  end;
 end;
 ////////////////  TMOVER     METHODS   **************


procedure TMover.Setorient(Value:TOrient);
 begin
  FOrient:=Value;

  case FOrient of
   S:Image:=TIngame(FEngine.Owner).Data.Agents.Items[id];
   V:Image:=TIngame(FEngine.Owner).Data.Agents.Items[id+1];
   J:Image:=TIngame(FEngine.Owner).Data.Agents.Items[id+2];
   Z:Image:=TIngame(FEngine.Owner).Data.Agents.Items[id+3];
  end;
 end;

function TMover.TestMove(Orient:TOrient):boolean;
var i,Modx,Mody:integer;
    ml,mr,mt,mb:integer;
    HR:TRect;
    WRS:array[1..9]of TRect;
    P:TPoint;
    const Can=Tile-20;
 begin
 with FEngine do
 begin
  ModX:=x;ModY:=y;

  Result:=true;

 case Orient of
  S:begin ModY:=Y-MoveSpeed;end;
  J:begin ModY:=Y+MoveSpeed;end;
  V:begin ModX:=X+MoveSpeed;end;
  Z:begin ModX:=X-MoveSpeed;end;
  end;

  ml:=tile div 4;mr:=tile div 4;mt:=tile-tile div 4;mb:=0;
  HR:=Classes.Rect(pos.x*tile+ModX+ml,pos.y*tile+ModY+mt,pos.x*tile+ModX+Tile-mr,pos.y*tile+ModY+Tile+mb);

  if  FEngine.BaseL[pos.x-1,pos.y-1]>=100 then WRS[1]:=Rect((pos.x-1)*Tile,(pos.y-1)*tile,pos.x*tile,pos.y*tile)
          else WRS[1]:=Rect(0,0,0,0);
  if  FEngine.BaseL[pos.x,pos.y-1]>=100 then WRS[2]:=Rect((pos.x)*Tile,(pos.y-1)*tile,(pos.x+1)*tile,pos.y*tile)
          else WRS[2]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y-1]>=100 then WRS[3]:=Rect((pos.x+1)*Tile,(pos.y-1)*tile,(pos.x+2)*tile,pos.y*tile)
          else WRS[3]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x-1,pos.y]>=100 then WRS[4]:=Rect((pos.x-1)*Tile,(pos.y)*tile,pos.x*tile,(pos.y+1)*tile)
          else WRS[4]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y]>=100 then WRS[5]:=Rect((pos.x+1)*Tile,(pos.y)*tile,(pos.x+2)*tile,(pos.y+1)*tile)
          else WRS[5]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x-1,pos.y+1]>=100 then WRS[6]:=Rect((pos.x-1)*Tile,(pos.y+1)*tile,pos.x*tile,(pos.y+2)*tile)
          else WRS[6]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x,pos.y+1]>=100 then WRS[7]:=Rect((pos.x)*Tile,(pos.y+1)*tile,(pos.x+1)*tile,(pos.y+2)*tile)
          else WRS[7]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x+1,pos.y+1]>=100 then WRS[8]:=Rect((pos.x+1)*Tile,(pos.y+1)*tile,(pos.x+2)*tile,(pos.y+2)*tile)
          else WRS[8]:=Rect(0,0,0,0);
 if  FEngine.BaseL[pos.x,pos.y]>=100 then WRS[9]:=Rect((pos.x)*Tile,(pos.y)*tile,(pos.x+1)*tile,(pos.y+1)*tile)
          else WRS[9]:=Rect(0,0,0,0);


 for i:=1 to 9 do
  begin
    if overlaprect(hr,wrs[i]) then result:=false;
  end;

  end;
 end;

procedure TMover.DoFire;
begin
 with TBounce.Create(FEngine) do
  begin
   ID:=Gun.ID;
   Image:=FEngine.Guns.Items[ID+MaxGuns];
   P:=Self.Pos;
   O:=Self.Orient;
   Owner:=Self;
  end;
 case TBounce(FEngine.GetActor(FEngine.allcount-1)).O of
   S:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+25;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y-12;end;

   V:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+81;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y+1;end;

   J:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+40;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y+55;end;

   Z:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X-16;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y+30;end;


   SZ:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X-20;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y-1;end;

   SV:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+73;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y-13;end;

   JV:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+85;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y+32;end;

   JZ:begin TBounce(FEngine.GetActor(FEngine.allcount-1)).X:=Pos.X*Tile+Self.X+1;
   TBounce(FEngine.GetActor(FEngine.allcount-1)).Y:=Pos.Y*Tile+Self.Y+43;end;





 end;


end;

procedure TMover.Fire;
begin
 if Gun.Counter>(1000 div Gun.Cad) then
   begin DoFire;Gun.Counter:=0;end
   else Inc(Gun.Counter,FEngine.Fps1);
end;

 //////////////// TENEMY  METHODS ///////////////////////
procedure TEnemy.DoMove;
 begin
  Moving:=true ;

 end;


/////////////// TPLAYER METHODS ///////////////////////
procedure TPlayer.DoMove;

 begin
  with FEngine do
   BEGIN
   Moving:=false;
     if isUp in Input.States then
      begin
      Orient:=S;
      if TestMove(Orient) then
      begin
      Y := Y - MoveSpeed;
      if y<-Tile+MoveSpeed  then
       begin
         dec(Pos.y);Y:=0; end;
       Moving:=true;
       end;
      end;
    if isDown in Input.States then
      begin
      Orient:=J;
      if TestMove(Orient) then
      begin
      Y := Y + MoveSpeed;
      if y > Tile -MoveSpeed then begin Inc(Pos.Y);Y:=0;end;
      Moving:=true;
      end;
      end;

    if isLeft in Input.States then
      begin
      Orient:=Z;
      if TestMove(Orient) then
      begin
      X := X - MoveSpeed;
      if x <-Tile +MoveSpeed then begin dec(Pos.x);x:=0;end;
      Moving:=true;
      end;
      end;
    if isRight in Input.States then
      begin
      Orient:=V;
      if TestMove(Orient) then
      begin
      X := X + MoveSpeed;
      if x >Tile -MoveSpeed then begin Inc(Pos.x);x:=0;end;
      Moving:=true;
      end;
      end;



   if (isLeft in Input.States)and(isDown in Input.States)then Orient:=JZ;
   if (isRight in Input.States)and(isUp in Input.States)then Orient:=SV;
   if (isRight in Input.States)and(isDown in Input.States)then Orient:=JV;
   if (isLeft in Input.States)and(isUp in Input.States)then Orient:=SZ;

   Input.Keyboard.KeyAssigns[isButton1,2]:=vk_space;

   if isButton1 in Input.States
    then Fire;



   if not Moving then dec(counter,fps1);

  END;
 end;

procedure TPlayer.DoDraw;
 var DrawX,DrawY:it;
 begin
  if Image=nil then Exit;
  Frames:=Image.Picture.Graphic.Width div Image.PatternWidth;
  DrawX:=(ViewWidth div 2)*Tile;
  DrawY:=(ViewHeight div 2)*Tile;

  if counter<0 then counter:=0;
  if Counter<FEngine.AnimSpeed
   then Inc(Counter,FEngine.FPS1)
    else
      begin
       Counter:=0;
       if ActFrame<Frames-1 then
         Inc(ActFrame)
        else ActFrame:=0;
      end;


  Image.Draw(FEngine.Draw.Surface,DrawX,DrawY,ActFrame);
 end;

 end.
