unit IngameC;
interface
uses Windows,DXDraws,DXSounds,DXInput,Classes,SysUtils,Jpeg,Types,Others,DXMenu,Graphics,IngClasses,DXSprite,DIB,Engine,forms;


type
   TOtype=(otreal,otfake);

   TOptions=record
             MoveSpeed,
             AnimSpeed:array[Totype]of integer;
             Acceleration,
             FullScreen,
             FPS:boolean;
             Wave,
             Midi:array[Totype]of integer;

             end;

   TBaseData=record
              Face:array[1..2]of byte;
              Name:array[1..2]of string;
              Cash:array[1..2]of integer;
              Equip:array[1..2]of record
                                   Armor:integer;
                                   Guns:array[1..3]of integer;
                                  end;
             end;

   TEBidding=record
              Selected:byte;
              AUp,
              GUp:integer;
              Armors:array[1..maxarmors]of integer;
              Guns:array[1..maxguns]of integer;
              Miscs:array[1..maxmiscs]of integer;
             end;

   TResType=(rtarmor,rtgun,rtmisc);

   TResearch=record
              Selected:boolean;
              Up:integer;
              Items:array[1..maxguns+maxmiscs+maxarmors]of
                    record
                     Typ:TResType;
                     ID:integer;
                    end;
             end;

   TIngame=class
	    Owner:TObject;
	    Draw:TDXDraw;
	    Sound:TDXSound;
	    Input:TDXInput;
            Eng:TEngine;

            BaseData:TBaseData;
	    Data:TData;
	    Menu:TDXMenu;
	    FState:TInGameState;
	    Active:boolean;
	    Tool:TDxTool;

            Bidding:TEBidding;
            Research:TResearch;
            Options:TOptions;
	    Kampan:TCamp;
	    Mise:TMission;
            FMode:TGameMode;
            APl:byte;
	    FStyle:TGameStyle;
	   private
	    procedure SetState(ST:TIngameState);
            procedure SetStyle(ST:TgameStyle);
            procedure SetMode(Value:TGameMode);
	   public
	    constructor Create(AOwner:TObject;SP:TStartPack);
	    destructor Destroy;override;
	    procedure Paint;
	    procedure Timer;
	    procedure MenuClick;
            procedure Keys(key:word;shift:tshiftstate);
            procedure Prepare;
            procedure BuyItem;
            procedure LoadResInfo;

            property State:TIngameState read FState write SetState;
	    property Style:TGameStyle read FStyle write SetStyle;
            property Mode:TGameMode read FMode write SetMode;
	   end;

const
   Opt:TOptions=(MoveSpeed:(4,5);AnimSpeed:(150,5);Acceleration:true;
   FullScreen:false;FPS:true;Wave:(0,5);Midi:(0,5));


implementation
uses ClassDef,Main;

const
 BD:TBaseData=(Face:(1,2);Name:('Bezejmenn Vsadk','Neznm Osoba');
    Cash:(820,820);Equip:((Armor:1;Guns:(1,0,0)),(Armor:1;Guns:(1,0,0)));
 );

 EB:TEBidding=(Selected:0;AUp:1;GUp:1;ArMors:(1,2,0,0,0);Guns:(1,2,3,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
    Miscs:(1,2,0,0,0));



 idparmor=5;
 idpgun1=6;
 idpgun2=7;
 idpgun3=8;
 idpmisc1=9;
 idpmisc2=10;
 idpmisc3=11;
 idpmisc4=12;
 idpmisc5=13;

 idbarmor=14;
 idbgun1=15;
 idbgun2=16;
 idbgun3=17;
 idbmisc1=18;
 idbmisc2=19;
 idbmisc3=20;
 idbmisc4=21;
 idbmisc5=22;

 idaup=23;
 idadown=24;
 idgup=25;
 idgdown=26;

 idmovel=2;
 idmover=3;
 idaniml=4;
 idanimr=5;
 idacel=6;
 idfull=7;
 idfps=8;
 idmidil=11;
 idmidir=12;
 idwavel=9;
 idwaver=10;



 basearmor=50;

var I:integer;
    P:TPoint;
    S:String;

 constructor TIngame.Create(AOwner:TObject;SP:TStartPack);
 var I:integer;
 begin
  inherited Create;
  Owner:=AOwner;
  Draw:=TGame(Owner).Draw;
  Sound:=TGame(Owner).Sound;
  Input:=TGame(Owner).Input;

  Data:=TGame(Owner).Data;
  Menu:=TGame(Owner).Menu;
  Active:=true;
  Kampan:=CKampan;
  Tool:=TDXTool.Create(Owner,Rect(0,0,0,0));
  Mise:=TMission.Create(Self);
  BaseData:=BD;
  Bidding:=EB;
  Research.Selected:=false;
  Research.Up:=1;
  for i:=1 to high(Research.Items) do
  begin
  Research.Items[i].ID:=0;
  end;

 // delete >
  Research.Items[1].ID:=5;
  Research.Items[1].Typ:=rtGun;
 { Research.Items[2].ID:=;
  Research.Items[2].Typ:=rtGun;
  }
 //  <
  Options:=TGame(Owner).Options;

  Apl:=1;

  Style:=SP.Style;
  Eng:=TEngine.Create(Self);
  Mode:=fmode;



 end;

destructor TIngame.Destroy;
 begin
  Mise.Free;
  Tool.Free;
  Eng.Free;
  Owner:=nil;
  Draw:=nil;
  Sound:=nil;
  Input:=nil;
  Menu:=nil;
  inherited Destroy;
 end;

procedure TIngame.SetState(St:TIngameState);
 begin
  FState:=ST;
  case State of
   isMain:begin

	   Data.igImages.Items.Find('mainbkg').draw(Draw.surface,0,0,0);
	   Draw.Surface.FillRectAdd(Rect(0,0,5+160+5,480),RGB(95,95,0));
	   Draw.Surface.FillRectAdd(Rect(475-5,0,640,480),RGB(95,95,0));
	   Data.igImages.Items.Find('Vanello').draw(Draw.surface,35,75+250,0);
	   Data.igImages.Items.Find('Vanello').draw(Draw.surface,470+35,75,0);
	   Menu.Load(Data.MenuList.Items.Find('IngameMain').Menu);
	   Menu.Active:=true;
	   Tool.free;
	   Tool:=TDXBkg.Create(Owner,Rect(0,0,640,480));
	  end;
   isBrief:begin
	    Tool.free;
	    Tool:=TDXTable.Create(Owner,Rect(0,0,640,480));
	    Menu.Load(Data.MenuList.Items.Find('OKBut').Menu);
	    Menu.Buttons[1].Caption:='Dal';
            Menu.Buttons[1].Top:=437;
	    TDXTable(Tool).Loadtable(ltBrief);
            TDXTable(Tool).LoadText(Data.ComTexts.Items.Find(Mise.Map.Brief).Strings);
	    Menu.Active:=true;
	   end;
  isGame:begin
          Prepare;

         end;
  isEquip:begin
           Tool.Free;
           Tool:=TDXEdit.Create(Owner,Rect(170,120,300,60));           TDXedit(Tool).Activate;
           Menu.Load(Data.MenuList.Items.Find('Equip').Menu);
           TDXEdit(Tool).Text:=BaseData.Name[Apl];
           TDXEdit(Tool).FName:=Menu.Font.name;
           TDXEdit(Tool).active:=false;

           Menu.Active:=true;
          end;
  isLab:begin
         Tool.Free;
         Tool:=TDXTable.create(Owner,Rect(210,45,380,110));
         LoadResInfo;
         Menu.Load(Data.MenuList.Items.Find('Research').Menu);
         Menu.Active:=true;
       end;
  isOpt:begin
         Data.IGImages.Items.Find('optbkg').draw(draw.surface,0,0,0);
         Draw.Surface.FillRectAdd(Rect(30,250,223,450),rgb(0,95,95));
         Draw.Surface.FillRectAdd(Rect(443,250,615,450),rgb(0,95,95));
         DrawBitlabel(Draw,Rect(40,255,213,285),'Rychlost',Data.Comimages.items.find('menu'),FontN,clYellow,14);
         DrawBitlabel(Draw,Rect(453,255,605,285),'Hlasitost',Data.Comimages.items.find('menu'),FontN,clYellow,14);
         DrawBitlabel(Draw,Rect(40,350,213,380),'DirectX',Data.Comimages.items.find('menu'),FontN,clYellow,14);

         Menu.Load(Data.MenuList.Items.Find('Opt').Menu);
         Menu.Active:=true;
         Tool.Free;
         Tool:=TDXBkg.create(Owner,Rect(0,0,640,480));

        end;
  end;
 Paint;
 end;

procedure TIngame.Paint;
 var x,y:integer;
 begin
  case State of
  ismain:begin
	 tdxbkg(tool).paint;
       	 Menu.Paint;
     //    Drawlabel(Draw,170,50,Basedata.name[apl],fontn,cllime,14);
         end;
  isBrief:begin
	   tdxtable(tool).paint;
	   Menu.Paint;
          end;
  isGame:begin

           Eng.DrawView;
         end;
  isEquip:begin
           Data.IGImages.Items.Find('equipbkg').Draw(Draw.Surface,0,0,0);
           Menu.Paint;
           TDXEdit(tool).Paint;
           Data.Faces.Items.Find(IntTostr(BaseData.Face[Apl])).StretchDraw(Draw.Surface,Rect(270,5,380,115),0);
           Data.IGImages.Items.Find('sell').StretchDraw(Draw.Surface,Rect(165,10,215,110),0);
           Data.IGImages.Items.Find('buy').StretchDraw(Draw.Surface,Rect(425,10,475,110),0);
           Data.ComImages.Items.Find('menu').StretchDraw(Draw.Surface,Rect(190,180,450,220),0);
           Data.ComImages.Items.Find('menu').StretchDraw(Draw.Surface,Rect(190,220,450,260),0);
           Data.ComImages.Items.Find('scrollbar').StretchDraw(Draw.Surface,Rect(477,30,497,90),0);
           Data.ComImages.Items.Find('scrollbar').StretchDraw(Draw.Surface,Rect(477,140,497,400),0);


             With Draw.Surface.Canvas do begin
              if Bidding.Selected<>0 then
              begin
              pen.Color:=clred;
              pen.Width:=3;
              brush.Style:=bsclear;
              Polygon([Point(Menu.Buttons[bidding.selected].left-3,Menu.Buttons[bidding.selected].top-3),
                            point(Menu.Buttons[bidding.selected].left+Menu.Buttons[bidding.selected].width,Menu.Buttons[bidding.selected].top-3),
                            point(Menu.Buttons[bidding.selected].left+Menu.Buttons[bidding.selected].width,Menu.Buttons[bidding.selected].top+Menu.Buttons[bidding.selected].height),
                            point(Menu.Buttons[bidding.selected].left-3,Menu.Buttons[bidding.selected].top+Menu.Buttons[bidding.selected].height)]);

              Font.name:='Arial CE';
              Font.Color:=clYellow;
              Font.Size:=8;
              Font.Style:=[fsBold];

              case Bidding.Selected of
              idparmor,idbarmor:begin
                                 if bidding.selected=idparmor then
                                    I:=BaseData.Equip[Apl].Armor else
                                    I:=Bidding.Armors[bidding.aup];
                                 TextOut(Menu.Buttons[bidding.selected].left+5,
                                  Menu.Buttons[bidding.selected].top+52,'Ochrana: '+ Inttostr(Armors[I].Quality));
                                 TextOut(Menu.Buttons[bidding.selected].left+5,
                                  Menu.Buttons[bidding.selected].top+67,'Cena: '+ Inttostr(Armors[I].Cost));
                                 end;
              idpgun1..idpgun3,idbgun1..idbgun3:
                                 begin
                                  if bidding.selected in [idpgun1..idpgun3] then
                                       I:=BaseData.Equip[Apl].Guns[Bidding.selected-idpgun1+1]
                                    else
                                       I:=Bidding.Guns[Bidding.Selected-idbgun1+Bidding.Gup];
                                 TextOut(Menu.Buttons[bidding.selected].left+5,
                                  Menu.Buttons[bidding.selected].top+52,'innost: '+ Inttostr(guns[I].Power));
                                 TextOut(Menu.Buttons[bidding.selected].left+5,
                                  Menu.Buttons[bidding.selected].top+67,'Kadence: '+ Inttostr(guns[I].Cad)+' ran/s' );
                                 TextOut(Menu.Buttons[bidding.selected].left+5,
                                  Menu.Buttons[bidding.selected].top+82,'Cena: '+ Inttostr(guns[I].Cost));
                                 end;

              end;
              end;

              Font:=Menu.buttons[1].Font;
              Font.Size:=12;
              SetBkMode(Handle,Transparent);
              TextOut(190+(260-TextWidth('FINANCE:  '+IntToStr(BaseData.Cash[Apl])+' Cr'))div 2,189,'FINANCE:  '+IntToStr(BaseData.Cash[Apl])+' Cr');
              s:='nil';
              case Bidding.Selected of
              idparmor:s:=Armors[BaseData.Equip[Apl].Armor].Name;
              idbarmor:s:=Armors[Bidding.Armors[Bidding.Aup]].Name;
              idpgun1..idpgun3:s:=Guns[BaseData.Equip[Apl].Guns[Bidding.Selected-idpgun1+1]].nAME;
              idbgun1..idbgun3:s:=Guns[Bidding.Guns[Bidding.Selected-idbgun1+Bidding.Gup]].Name;

              end;
              Font.Size:=10;
              TextOut(190+(260-TextWidth('Vybran:  '+s))div 2,231,'Vybran:  '+s);
              Release;
             end;
           if Basedata.Equip[Apl].Armor<>0 then
              Data.Guns.Items[BaseData.Equip[Apl].Armor+basearmor].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idparmor].left+10,Menu.Buttons[idparmor].top+3,Menu.Buttons[idparmor].left-10+130,Menu.Buttons[idparmor].top+3+50),0);
           if Basedata.Equip[Apl].Guns[1]<>0 then
              Data.Guns.Items[BaseData.Equip[Apl].Guns[1]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idpgun1].left+10,Menu.Buttons[idpgun1].top+3,Menu.Buttons[idpgun1].left-10+130,Menu.Buttons[idpgun1].top+3+50),0);
           if Basedata.Equip[Apl].Guns[2]<>0 then
              Data.Guns.Items[BaseData.Equip[Apl].Guns[2]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idpgun2].left+10,Menu.Buttons[idpgun2].top+3,Menu.Buttons[idpgun2].left-10+130,Menu.Buttons[idpgun2].top+3+50),0);
           if Basedata.Equip[Apl].Guns[3]<>0 then
              Data.Guns.Items[BaseData.Equip[Apl].Guns[3]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idpgun3].left+10,Menu.Buttons[idpgun3].top+3,Menu.Buttons[idpgun3].left-10+130,Menu.Buttons[idpgun3].top+3+50),0);

           Data.Guns.Items[Bidding.Armors[bidding.aup]+basearmor].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idbarmor].left+10,Menu.Buttons[idbarmor].top+3,Menu.Buttons[idbarmor].left-10+130,Menu.Buttons[idbarmor].top+3+50),0);
           if Bidding.Guns[bidding.gup]<>0 then
              Data.Guns.Items[Bidding.Guns[bidding.gup]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idbgun1].left+10,Menu.Buttons[idbgun1].top+3,Menu.Buttons[idbgun1].left-10+130,Menu.Buttons[idbgun1].top+3+50),0);
           if Bidding.Guns[bidding.gup+1]<>0 then
              Data.Guns.Items[Bidding.Guns[bidding.gup+1]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idbgun2].left+10,Menu.Buttons[idbgun2].top+3,Menu.Buttons[idbgun2].left-10+130,Menu.Buttons[idbgun2].top+3+50),0);
           if Bidding.Guns[bidding.gup+2]<>0 then
              Data.Guns.Items[Bidding.Guns[bidding.gup+2]].StretchDraw(Draw.Surface,Rect(Menu.Buttons[idbgun3].left+10,Menu.Buttons[idbgun3].top+3,Menu.Buttons[idbgun3].left-10+130,Menu.Buttons[idbgun3].top+3+50),0);



          end;
 isLab:begin
        Data.IGImages.Items.Find('equipbkg').Draw(Draw.Surface,0,0,0);
        Menu.Paint;
        TDXTable(Tool).Paint;
        Data.ComImages.Items.Find('menu').StretchDraw(Draw.Surface,Rect(190,180,450,220),0);
        Data.ComImages.Items.Find('scrollbar').StretchDraw(Draw.Surface,Rect(185,70,205,130),0);
         With Draw.Surface.Canvas do
         begin
           if Research.Selected then
            begin
              pen.Color:=clred;
              pen.Width:=3;
              brush.Style:=bsclear;
              Polygon([Point(Menu.Buttons[2].left-3,Menu.Buttons[2].top-3),
                            point(Menu.Buttons[2].left+Menu.Buttons[2].width,Menu.Buttons[2].top-3),
                            point(Menu.Buttons[2].left+Menu.Buttons[2].width,Menu.Buttons[2].top+Menu.Buttons[2].height),
                            point(Menu.Buttons[2].left-3,Menu.Buttons[2].top+Menu.Buttons[2].height)]);
            end;

           Font:=Menu.buttons[1].Font;
              Font.Size:=12;
              SetBkMode(Handle,Transparent);
              TextOut(190+(260-TextWidth('FINANCE:  '+IntToStr(BaseData.Cash[Apl])+' Cr'))div 2,189,'FINANCE:  '+IntToStr(BaseData.Cash[Apl])+' Cr');


          Release;
        end;

        case Research.Items[Research.Up].Typ of
        rtArmor:Data.Guns.Items[Research.Items[Research.Up].ID+basearmor].StretchDraw(Draw.Surface,Rect(Menu.Buttons[2].Left+1,Menu.Buttons[2].Top+15,Menu.Buttons[2].Left+130-1,Menu.Buttons[2].Top+70+15),0);
      //  rsMisc:Data.Guns.Items[Research.Items[Research.Up].ID].StretchDraw(Draw.Surface,Rect(Menu.Buttons[2].Left+10,Menu.Buttons[2].Top+3,Menu.Buttons[2].Left+130-10,Menu.Buttons[2].Top+53),0);
        rtGun:Data.Guns.Items[Research.Items[Research.Up].ID].StretchDraw(Draw.Surface,Rect(Menu.Buttons[2].Left+1,Menu.Buttons[2].Top+15,Menu.Buttons[2].Left+130-1,Menu.Buttons[2].Top+70+15),0);
        end;
       end;
  isOpt:begin
         TDXBkg(Tool).Paint;
         with Draw.Surface.Canvas do
          begin
           Font.Name:='Arial Black';
           Font.Style:=[fsitalic];
           Font.Color:=clRed;
           Font.Size:=12;
           SetBkMode(Handle,Transparent);
           TextOut(40,290,'Pohyb');
           TextOut(40,310,'Animace');
           TextOut(40,385,'Akcelerace');
           TextOut(40,405,'FullScreen');
           TextOut(40,425,'FPS');
           TextOut(453,290,'Zvuk');
           TextOut(453,310,'Midi');

           Font.Style:=[fsbold];
           Font.Color:=clWhite;
           Font.Size:=14;

           TextOut(170-TextWidth(inttostr(options.movespeed[otfake])),288,InttoStr(Options.MoveSpeed[otfake]));
           TextOut(170-TextWidth(inttostr(options.animspeed[otfake])),308,InttoStr(Options.animSpeed[otfake]));

           TextOut(565-TextWidth(inttostr(options.wave[otfake])),288,InttoStr(Options.wave[otfake]));
           TextOut(565-TextWidth(inttostr(options.midi[otfake])),308,InttoStr(Options.midi[otfake]));

           Font.Size:=12;
           Font.Style:=[];
           S:='';
           if Options.Acceleration then S:='true' else s:='false';
           TextOut(190-TextWidth(s),385,s);
           if Options.FullScreen then S:='true' else s:='false';
           TextOut(190-TextWidth(s),405,s);
           if Options.FPS then S:='true' else s:='false';
           TextOut(190-TextWidth(s),425,s);


           Release;
          end;
         Menu.Paint;


        end;

  end;
 end;

procedure TIngame.Timer;
 begin
  case State of
  isGame:begin

    Eng.MoveActors;
   end;
  isequip:if Bidding.Selected<>0 then
            begin
             GetCursorPos(P);
             if PtInRect(Rect(Menu.Buttons[Bidding.Selected].Left,Menu.Buttons[Bidding.Selected].top,Menu.Buttons[Bidding.Selected].Left+Menu.Buttons[Bidding.Selected].width,Menu.Buttons[Bidding.Selected].top+Menu.Buttons[Bidding.Selected].height),P)
               then  TGame(Owner).Cur.Load(Data.ComImages.Items.Find('curbuy'))
             else if TGame(Owner).Cur.Style=csStatic then
               Tgame(owner).cur.load(data.comimages.items.find('curdef'));
             end;
  isLab:if Research.Selected then
       begin
         GetCursorPos(P);
          if PtInRect(Rect(Menu.Buttons[2].Left,Menu.Buttons[2].top,Menu.Buttons[2].Left+Menu.Buttons[2].width,Menu.Buttons[2].top+Menu.Buttons[2].height),P)
            then
             TGame(Owner).Cur.Load(Data.ComImages.Items.Find('curres'))
            else if TGame(Owner).Cur.Style=csStatic then
               Tgame(owner).cur.load(data.comimages.items.find('curdef'));

        end;
  end;
 end;

procedure TIngame.Keys(key:word;shift:tshiftstate);
 begin
  case State of
   isEquip:begin
             tdxedit(tool).keys(key,shift);

           end;

  end;
 end;

procedure TIngame.MenuClick;
 var i:integer;
   
 begin
  case STate of
   ismain:case menu.Selected of
            1:State:=isGame;
	    2:State:=isBrief;
            3:State:=isEquip;
            4:State:=isLab;
            5:State:=isOpt;

	    8:TGame(Owner).EndInGame;
	  else menu.Active:=true;
	  end;
  isBrief:State:=isMain;
  isEquip:begin
           case Menu.Selected of
           2:begin TDXEdit(Tool).Activate;Menu.Active:=true;end;
           1:State:=isMain;
           3:if BaseData.Face[Apl]>1 then Dec(Basedata.Face[Apl]);
           4:if BaseData.Face[Apl]<Data.faces.Items.Count then Inc(Basedata.Face[Apl]);
           idparmor..idbmisc5:if Bidding.Selected<>menu.selected then Bidding.Selected:=Menu.Selected else BuyItem;
           idgdown:if Bidding.Guns[Bidding.gup+3]<>0 then Inc(Bidding.gup);
           idgup:if Bidding.Guns[Bidding.gup-1]<>0 then dec(Bidding.gup);
           idadown:if Bidding.Armors[Bidding.aup+1]<>0 then Inc(Bidding.aup);
           idaup:if Bidding.Armors[Bidding.aup-1]<>0 then dec(Bidding.aup);
           end;
           menu.active:=true;
           if Menu.selected<>2 then TDXEdit(Tool).Active:=false;
           if not(menu.selected in [idparmor..idbmisc5]) then Bidding.Selected:=0;
          end;
  isLab:begin
        case Menu.Selected of
         1:begin Research.Selected:=false;State:=isMain;end;
         3:begin Research.Selected:=false;if Research.Up>1 then Dec(Research.Up);LoadResInfo;end;
         4:begin Research.Selected:=false;if Research.Items[Research.Up+1].ID<>0 then Inc(Research.Up);LoadResInfo;end;
         2:begin
            if not Research.Selected then Research.Selected:=true
              else
               begin
                case Research.Items[Research.Up].Typ of
                 rtArmor:for i:=1 to maxarmors do
                          if Bidding.Armors[i]=0 then
                          begin
                          Bidding.Armors[i]:=Research.Items[i].ID;
                          Data.IGSounds.Items.Find('research').Play(false);
                          Break;
                         end;
                  rtGun:for i:=1 to maxguns do
                          if Bidding.Guns[i]=0 then
                          begin
                          Bidding.Guns[i]:=Research.Items[Research.Up].ID;
                          Data.IGSounds.Items.Find('research').Play(false);
                          Break;
                         end;
                  rtMisc:

                end;
               end;
           end;
         else menu.Active:=true;
       end;
        menu.active:=true;
      end;
  isOpt:begin
       case Menu.Selected of
        1:begin TGame(Owner).Options:=Options;TGame(Owner).WriteIni;State:=isMain;end;
        idmovel:if options.MoveSpeed[otfake]>0 then dec(options.movespeed[otfake]);
        idmover:if options.MoveSpeed[otfake]<10 then inc(options.movespeed[otfake]);
        idaniml:if options.AnimSpeed[otfake]>0 then dec(options.animspeed[otfake]);
        idanimr:if options.AnimSpeed[otfake]<10 then inc(options.animspeed[otfake]);
        idacel:begin
               options.acceleration:=not (options.acceleration);
                if options.acceleration then Draw.Options:=Draw.Options+[doHardware] else
                   Draw.Options:=Draw.Options-[doHardware];
               Draw.Initialize;
               end;
        idfull:begin
               Draw.Finalize;
               options.fullscreen:=not (options.fullscreen);

               if doFullScreen in Draw.Options then
               begin
               TF(TGame(Owner).Owner).RestoreWindow;

              TF(TGame(Owner).Owner).BorderStyle := bsSingle;
              Draw.Options := Draw.Options - [doFullScreen];
              end else
              begin
              TF(TGame(Owner).Owner).StoreWindow;

              TF(TGame(Owner).Owner).borderStyle := bsNone;
              Draw.Options := Draw.Options + [doFullScreen];
              end;
              Draw.Initialize;
              end;
         idfps:begin options.fps:=not options.fps;TGame(owner).options:=options;end;

        end;
        menu.Active:=true;
      end;
  end;
 end;

procedure TIngame.SetStyle(ST:TGameStyle);
 begin
  FStyle:=ST;
  case ST of
   gsKampan:begin
             fMode:=gmSingle;
             Mise.ID:=1;
	     Mise.Load(Kampan[Mise.ID]);
             State:=isMain;
	    end;
   gsMise:begin
           fMode:=gmsplit;
           Mise.ID:=1;
	   Mise.Load('Single');
           State:=isMain;

          end;
  end;
 end;

procedure TIngame.SetMode(Value:TGameMode);
 begin
  FMode:=Value;
  case Value of
   gmsingle:begin
             Eng.Players:=1;
             ViewWidth:=9;
             ViewHeight:=7;
            end;
   gmsplit:begin
             Eng.Players:=2;
             ViewWidth:=5;
             ViewHeight:=7;
           end;
  end;
 end;

procedure TIngame.Prepare;
var i:it;
begin

  TBackground.Create(Eng,Rect(0,0,400,400));

   with TPlayer.Create(Eng) do
    begin
     Pos:=Point(37,37);
     id:=0;
     gun:=guns[7];
    end;

    for i:=1 to 610 do
     with TEnemy.Create(Eng) do
    begin
     Image:=TGame(Owner).Data.Agents.Items[0];
     Pos:=Point(10+random(50),10+random(50));
     HP:=20;
    end;


 end;

procedure TIngame.BuyItem;
 var S:boolean;
     I:Integer;
 begin
  S:=false;
  case Bidding.Selected of
   idparmor..idpmisc5:case Bidding.Selected of
                        idparmor:if BaseData.Equip[Apl].Armor<>0 then
                                  begin
                                   Inc(BaseData.Cash[Apl],Armors[BaseData.Equip[Apl].Armor].Cost);
                                   BaseData.Equip[Apl].Armor:=0;
                                   S:=true;
                                  end;
                        idpgun1..idpgun3:
                                  if BaseData.Equip[Apl].Guns[Bidding.Selected-idpgun1+1]<>0 then
                                    begin
                                     Inc(BaseData.Cash[Apl],Guns[BaseData.Equip[Apl].Guns[Bidding.Selected-idpgun1+1]].Cost);
                                     BaseData.Equip[Apl].Guns[Bidding.Selected-idpgun1+1]:=0;
                                     S:=true;
                                    end;
                        idpmisc1..idpmisc5:

                      end;
    idbarmor..idbmisc5: case Bidding.Selected of
        idbarmor:if  BaseData.Equip[Apl].Armor=0 then
                  begin
                   if Armors[Bidding.Armors[Bidding.Aup]].Cost>Basedata.Cash[Apl] then Exit;
                   Dec(Basedata.Cash[Apl],Armors[Bidding.Armors[Bidding.Aup]].Cost);
                   BaseData.equip[Apl].Armor:=Armors[Bidding.Armors[Bidding.Aup]].ID;
                   S:=true;
                  end;
        idbgun1..idbgun3:for I:=1 to 3 do
                           if Basedata.Equip[Apl].Guns[i]=0 then
                            begin
                             if  Guns[Bidding.Guns[Bidding.Selected-idbgun1+Bidding.Gup]].Cost>Basedata.cash[Apl] then Exit;
                             Dec(Basedata.cash[Apl],Guns[Bidding.Guns[Bidding.Selected-idbgun1+Bidding.Gup]].Cost);
                             BaseData.Equip[Apl].Guns[I]:=Guns[Bidding.Guns[Bidding.Selected-idbgun1+Bidding.Gup]].ID;
                             S:=true;
                             Break;
                            end;
        idbmisc1..idbmisc5:
       end;
   end;

  if S then Data.IGSounds.Items.Find('BuySell').Play(false);
  end;

procedure TIngame.LoadResInfo;
 begin
  TDXTable(Tool).Text.Clear;
  TDXTable(Tool).Font.Color:=clYellow;
  TDXTable(Tool).Font.Size:=10;
  TDXTable(Tool).Font.Name:='Arial CE';

  with TDXTable(Tool).Text do
  case Research.Items[Research.Up].Typ of
   rtArmor:begin
            Add(Armors[research.items[research.up].id].Name);
            Add('Pedpokldan ochrana: '+IntToStr(round((Armors[research.items[research.up].id].Quality/ 100)*60))+' - '+IntToStr(round((Armors[research.items[research.up].id].Quality/ 100)*140)));
            Add('Pedpokldan cena: '+IntToStr(round((Armors[research.items[research.up].id].cost/ 100)*60))+' - '+IntToStr(round((Armors[research.items[research.up].id].cost/ 100)*140)));
            Add('Nklady na vzkum: '+IntToStr(Armors[research.items[research.up].id].rescost));
           end;
  rtGun:begin
            Add(Guns[research.items[research.up].id].Name);
            Add('Pedpokldan innost: '+IntToStr(round((guns[research.items[research.up].id].power/ 100)*60))+' - '+IntToStr(round((guns[research.items[research.up].id].power/ 100)*140)));
            Add('Pedpokldan cena: '+IntToStr(round((guns[research.items[research.up].id].cost/ 100)*60))+' - '+IntToStr(round((guns[research.items[research.up].id].cost/ 100)*140)));
            Add('Nklady na vzkum: '+IntToStr(guns[research.items[research.up].id].rescost));
           end;


  end;
 end;

end.
