unit Main;

interface

uses
  Windows,SysUtils, Classes,Graphics,Forms,DXDraws, DXSounds, DXClass,types, MenuList,  DXInput, TextList,
  Controls, MapList, DXSprite,ClassDef,Engine, StdCtrls;

type
  TF = class(TDXForm)
    DxDraw: TDXDraw;
    DXSound: TDXSound;
    NGImages: TDXImageList;
    DXTimer: TDXTimer;
    CommonImages: TDXImageList;
    CommonWaves: TDXWaveList;
    MenuList: TMenuList;
    DXInput: TDXInput;
    CommonTexts: TTextList;
    IGImages: TDXImageList;
    MapList: TMapList;
    DXEngine: TDXSpriteEngine;
    AgentFrames: TDXImageList;
    Base: TDXImageList;
    GEImages: TDXImageList;
    Faces: TDXImageList;
    IGSounds: TDXWaveList;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure Quit;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F: TF;
  Game:TGame;

implementation
//uses ClassDef;
{$R *.DFM}

var
  InitFirst:boolean=true;


procedure TF.FormCreate(Sender: TObject);
begin
 AddFontresource('data\Font.ttf');
 //

end;

procedure TF.FormShow(Sender: TObject);
begin
 if InitFirst then dxtimer.enabled:=true;
end;

procedure TF.DXTimerTimer(Sender: TObject; LagCount: Integer);

begin
 if InitFirst then
  begin
   Game:=TGame.Create(Self);
   InitFirst:=false;
  end;


  game.paint;
  game.timer;
  if DXTimer.Framerate<>0 then game.fps1:=1000 div DXTimer.Framerate;
  with DXDraw.Surface.Canvas do
  begin

    SetBkMode(handle,transparent);
    Font.Color := clred;
    Font.Name:=FontN;
    Font.Size := 12;
    if Game.Options.fps then
    Textout(5, 5, 'FPS: '+inttostr(DXTimer.FrameRate));


    ///    delete >>
    if (Game.State=gsingame)and(game.ingame.State=isgame) then

    Textout(5, 45, 'count: '+inttostr(Game.Ingame.Eng.AllCount));

     Font.Size:=10;
     Font.name:='Arial';
    TextOut(305,5,'Alt+Enter =Toggle FullScreen');

   //  <<


    Release;
  end;


   dxdraw.flip;
end;

procedure TF.Quit;
begin
 Game.Quit;
 Close;
end;

procedure TF.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key=vk_escape then Quit;

 if (ssAlt in Shift) and (Key=VK_RETURN) then
  begin
    DXDraw.Finalize;

    if doFullScreen in DXDraw.Options then
    begin
      RestoreWindow;

      BorderStyle := bsSingle;
      DXDraw.Options := DXDraw.Options - [doFullScreen];
    end else
    begin
      StoreWindow;
     
      BorderStyle := bsNone;
      DXDraw.Options := DXDraw.Options + [doFullScreen];
    end;

    DXDraw.Initialize;
  end;
 if Game<>nil then Game.Keys(Key,Shift);
end;


end.
