unit Others;

interface

uses Windows,DxDraws,Classes,Graphics,dib,types,textlist,SysUtils,stdctrls,controls,messages;
type
     TDXTool=class
              Owner:TObject;
              Left,
              Top,
              Width,
              Height:It;

             public
              constructor Create(AOwner:TObject;R:TRect);virtual;
              destructor Destroy;override;

             end;

     TCurStyle=(csStatic,csAnimated);

     TDXCursor=class
              Loop:dword;
              AFrame,
              Frames:word;
              Style:TCurStyle;
              Image,
              Temp:TBitmap;
              Owner:TObject;
             public
              constructor Create(AOwner:TObject);
              destructor  Destroy;override;
	      procedure Load(Source:TPictureCollectionItem);
              procedure Paint;

             end;

     TltTables=(ltInfo,ltStory,ltBrief);

     TDXTable=class(TDXTool)
	       Text:TStringList;
	       InImage,
	       OutImage:string;
	       Frame:it;
	       Font:TFont;
	       Lines,
	       UpLine,
	       LineH:it;
	       ScrollBar:boolean;
               procedure SetUpLine(Value:It);
	      public
	       constructor Create(AOwner:TObject;R:TRect);override;
	       destructor Destroy;override;
	       procedure Paint;
	       procedure LoadText(Str:TStr);
	       procedure Loadtable(Tab:tlttables);
	       procedure Click;
	       property Up:it read UpLine write SetUpLine;
              end;

   TDXBkg=class(TDXTool)
	     Surface:TDIB;

           public
	     constructor Create(AOwner:TObject;R:TRect);override;
             destructor Destroy;override;
	     procedure Paint;

          end;

   TDXEdit=class(TDXTool)
            Back,
            Front:string;
            Frame:integer;
            Pos:integer;
            Text:string;
            Active:boolean;
            FName:string;
            FAColor,
            FColor:TColor;
            FSize:integer;
            FMax:integer;
           public

            constructor Create(AOwner:TObject;R:TRect);override;
            destructor Destroy;override;
            procedure Activate;
            procedure Keys(key:word;shift:tshiftstate);
            procedure Paint;
            property Max:integer read FMax;

          end;

   { TDXList=class(TDXTool)



            public


            end;
              }

implementation

uses classdef,main;

///// TDX TOOL METHODS *******************
constructor  TDXTool.Create(AOwner:TObject;R:TRect);
 begin
  inherited Create;
   Owner:=AOwner;
   Left:=R.Left;
   Top:=R.Top;
   Width:=R.Right;
   Height:=R.Bottom;

 end;

destructor TDXTool.Destroy;
 begin

  Owner:=nil;
  inherited Destroy;
 end;
///  TDX CURSOR METHODS  ////


constructor TDXCursor.Create(AOwner:TObject);
 begin
  inherited Create;
  Owner:=AOwner;
  Loop:=0;
  AFrame:=0;
  Frames:=0;
  Image:=TBitmap.Create;
  Temp:=TBitmap.Create;
  Style:=csStatic;
  Load(TGame(Owner).Data.ComImages.Items.Find('curdef'));
 end;

procedure TDXCursor.Paint;
 var P:TPoint;

 begin
  if not Image.Empty then
  begin

  GetCursorPos(P);
  if Style=csStatic then
   TGame(Owner).draw.surface.Canvas.Draw(p.x,p.y,Image)
  else
   begin
    if loop>200 then
     begin
      if AFrame<Frames then Inc(AFrame)
     else AFrame:=1;
      loop:=0;
      end  else Inc(Loop,TGame(Owner).Fps1);


     temp.Canvas.CopyRect(Rect(0,0,image.height,image.height),
     image.Canvas,Rect(Image.Height*(AFrame-1),0,Image.height*AFrame,Image.Height));

       TGame(Owner).draw.surface.Canvas.Draw(p.x,p.y,temp)
     end;
   TGame(Owner).draw.surface.Canvas.release;

  end;
 end;

procedure TDXCursor.Load(Source:TPictureCollectionItem);

 begin
   AFrame:=0;
  Frames:=0;

  if Source.Picture.Graphic is TDIB
   then
    begin
     Image.Width:=Source.Picture.Graphic.Width;
     Image.Height:=Source.Picture.Graphic.height;
     Image.Canvas.CopyRect(Rect(0,0,Image.Width,Image.height),TDIB(Source.Picture.Graphic).Canvas,Rect(0,0,Image.Width,Image.height));

    end else
  Image.Assign(Source.Picture.graphic);
  Style:=csStatic;
  if image.Width>image.Height then
   begin
     Temp.Height:=Image.Height;
     Temp.Width:=Image.Height;
     Temp.PixelFormat:=pf24bit;
     Style:=csAnimated;
     Frames:=image.Width div image.height;

   end ;
  Temp.Transparent:=true;
  Temp.TransparentColor:=clBlack;
  Image.Transparent:=true;
  Image.TransparentColor:=clBlack;
 end;

destructor TDXCursor.Destroy;
 begin
  Image.free;
  Temp.Free;
  Owner:=nil;
  inherited Destroy;
 end;

/////  TDX TABLE    METHODS********************************
constructor TDXTable.Create(AOwner:TObject;R:TRect);
 begin
  inherited Create(AOwner,R);
  Text:=TStringList.Create;
  Font:=TFont.Create;
  outimage:='hull';
  inimage:='console';
  frame:=10;
   ScrollBar:=false;
 end;

destructor TDXTable.Destroy;
 begin
  Text.Free;
  Font.Free;
  inherited destroy;
 end;

procedure TDXTable.Paint;
var i,Max:integer;
 begin

  if outimage<>'' then TGame(Owner).Data.ComImages.Items.Find(outimage).stretchdraw(TGame(Owner).draw.surface,Rect(Left,Top,left+Width,Top+Height),0);
  if inimage<>'' then TGame(Owner).Data.ComImages.Items.Find(inimage).stretchdraw(TGame(Owner).draw.surface,Rect(Left+Frame,Top+Frame,left+Width-Frame,Top+Height-Frame),0);
  if scrollbar then
   begin
    if (Text.Count-UpLine)>Lines then
     TGame(Owner).Draw.Surface.Canvas.Draw(Left+Width-Frame-38,Top+Height-Frame-38, TGame(Owner).Data.ComImages.Items.Find('scrolldown').Picture.Graphic);
    if UpLine<>0 then
	TGame(Owner).Draw.Surface.Canvas.Draw(Left+Width-Frame-38,Top+Frame+6, TGame(Owner).Data.ComImages.Items.Find('scrollup').Picture.Graphic);
	TGame(Owner).Draw.Surface.Canvas.StretchDraw(Rect(Left+Width-Frame-38+6,Top+Frame+38,Left+Width-Frame-38+26,Top+Height-Frame-38),TGame(Owner).Data.ComImages.Items.Find('scrollbar').Picture.Graphic);

      end;

   TGame(Owner).draw.surface.Canvas.Font.Assign(Font);
   LineH:=TGame(Owner).draw.surface.Canvas.TextHeight('H')+TGame(Owner).draw.surface.Canvas.Textheight('H')div 3;
   Lines:=(Height-2*Frame)div LineH;
   SetBkMode(TGame(Owner).draw.surface.Canvas.Handle,transparent);
   Up:=Upline;
   if UpLine+Lines>Text.Count-1 then Max:=Text.Count-1
    else max:=Upline+Lines;
   for i:=Upline to Max do
   begin
   TGame(Owner).draw.surface.Canvas.TextOut(Left+frame+round(1.5*TGame(Owner).draw.surface.Canvas.TextWidth('M')),Top+Frame+(i+1-upline)*TGame(Owner).draw.surface.Canvas.TextHeight('H'),string(Text.Strings[i]));
   end;

   TGame(Owner).draw.surface.Canvas.release;
 end;

procedure TDXTable.LoadText(Str:TStr);
 var i:it;
 begin
   Text.Clear;
  for i:=0 to Str.Size-1 do
   Text.Add(String(Str.Data.Text[i]));
  Upline:=0;
  ScrollBar:=false;

 end;

procedure TDXTable.Loadtable(Tab:tlttables);
 var St:string;
 begin
  case Tab of
   ltInfo:begin
	   inimage:='console';
	   outimage:='hull';
	   Frame:=20;
	   Font.Name:='Arial Black';
	   Font.Size:=12;
	   Font.Style:=[fsItalic];
	   Font.Color:=clyellow;
	   St:='Info';
	  end;
    ltStory:begin
	   inimage:='';
	   outimage:='';
	   Frame:=0;
	   Font.Name:='Arial';
	   Font.Size:=12;
	   Font.Style:=[fsItalic,fsBold];
	   Font.Color:=clyellow;
	   St:='Story';
	  end;
      ltBrief:begin
	   inimage:='console';
	   outimage:='hull';
	   Frame:=50;
	   Font.Name:='Arial';
	   Font.Size:=12;
	   Font.Style:=[fsItalic,fsBold];
	   Font.Color:=clyellow;
	   St:='Story';
	  end;

   end;
 LoadText(TGame(Owner).Data.ComTexts.Items.Find(St).Strings);
 end;

procedure TDXTable.SetUpLine(Value:IT);
 begin
  UpLine:=Value;
  if Text.Count>Lines then ScrollBar:=true;
 end;

procedure TDxTable.Click;
 var P:TPoint;
 begin
  GetCursorPos(P);
  if (Text.Count-UpLine)>Lines then
    if PtInRect(Rect(Left+Width-Frame-38,Top+Height-Frame-38,Left+Width-Frame-38+32,Top+Height-Frame-38+32),P)
     then if ( GetKeyState(vk_lbutton)<0)
       then SetUpLine(UpLine+1);
  if UpLine<>0 then
  if PtInRect(Rect(Left+Width-Frame-38,Top+Frame+6,Left+Width-Frame-38+32,Top+Frame+38),P)
     then if ( GetKeyState(vk_lbutton)<0)
       then SetUpLine(UpLine-1);

 end;
 //////  TDX BKG METHODS



constructor TDXbkg.Create(AOwner:TObject;R:TRect);
 begin
  inherited Create(AOwner,R);

 Surface:=TDiB.Create;
 surface.SetSize(r.right,r.bottom,24);

 if TGame(Owner).Draw.CanDraw then
 begin
  Surface.Canvas.CopyRect(Scr,Tgame(Owner).Draw.surface.Canvas,Rect(r.left,r.top,r.left+r.right,r.top+R.bottom));
  TGame(Owner).Draw.Surface.Canvas.release;
 end;

 end;

destructor TDXbkg.Destroy;
 begin
 Surface.Free;
 inherited Destroy;
 end;


procedure TDXbkg.Paint;
 begin
 TGame(Owner).Draw.Surface.Canvas.Draw(Left,Top,Surface);
 TGame(Owner).Draw.Surface.Canvas.Release;
 end;

///////////////         TDX  EDIT METHODS ***********
constructor TDXEdit.Create(AOwner:TObject;R:TREct);
 begin
  inherited Create(AOwner,R);
  Text:='';
  Back:='menu';
  Front:='console';
  Frame:=15;
  Pos:=1;
  FSize:=14;
  FColor:=clRed;
  FAColor:=clFuchsia;
  FName:='Arial';
  Active:=false;
 end;

destructor TDXEdit.Destroy;
 begin
  inherited Destroy;
 end;

procedure TDXEdit.Activate;
 begin
  Active:=true;
  Pos:=1;
 end;


procedure TDXEdit.Paint;
 var TextX,TextY:integer;
     len:string;
  TotSpace:integer;


 begin
  if  not TGame(Owner).draw.Candraw then exit;
   TotSpace:=Width-2*Frame-10;

   TGame(Owner).Data.Comimages.Items.Find(back).stretchdraw(tgame(owner).draw.surface,Rect(left,top,left+width,top+height),0);
   if Active then TGame(Owner).Data.Comimages.Items.Find(front).stretchdraw(tgame(owner).draw.surface,Rect(left+frame,top+frame,left+width-frame,top+height-frame),0);

   FMax:=TotSpace div TGame(Owner).draw.Surface.Canvas.TextWidth('N');
   TextX:=(Width-TGame(Owner).draw.Surface.Canvas.TextWidth(text))div 2+Left;
   TextY:=(Height-TGame(Owner).draw.Surface.Canvas.TextHeight(text))div 2+Top;

   TGame(Owner).draw.Surface.Canvas.Font.Name:=FName;
   TGame(Owner).draw.Surface.Canvas.Font.Size:=FSize;
   TGame(Owner).draw.Surface.Canvas.Font.Color:=FColor;
   if Active then
   begin
   TGame(Owner).draw.Surface.Canvas.Font.Color:=clwhite;
   len:=copy(Text,0,Pos-1);
   SetBkMode(TGame(Owner).draw.Surface.Canvas.Handle,transparent);
   TGame(Owner).draw.Surface.Canvas.TextOut(
   textx+TGame(Owner).draw.Surface.Canvas.TextWidth(len),
   textY+3,'_');
    TGame(Owner).draw.Surface.Canvas.Font.Color:=FAColor;
     end;

  SetBkMode(TGame(Owner).draw.Surface.Canvas.Handle,transparent);
  TGame(Owner).draw.Surface.Canvas.TextOut(TextX,TextY,text);
   TGame(Owner).draw.Surface.Canvas.Release;


 end;

procedure TDXEdit.Keys(key:word;shift:tshiftstate);
 begin
  if not Active then Exit;
   case Key of
   vk_space:if (Pos<Max)and(length(text)<max) then begin insert(' ',text,pos);Inc(pos);end;
   vk_delete:if pos>0 then begin delete(text,pos,1);;end;
   vk_back: if pos>1 then begin delete(text,pos-1,1);dec(pos);end;
   vk_left:if pos>1 then dec(pos);
   vk_right:if pos<LEngth(text)+1 then inc(pos);
   vk_return:Active:=false;
   vk_menu,vk_control,vk_tab,vk_capital,vk_shift:
   else if (pos<max)and(length(text)<max) then begin insert(char(key),text,pos);inc(pos);end;
   end;
   end;


 end.
