unit Types;

interface
uses Windows,Dxdraws,Dxsounds,Classes,SysUtils,maplist,menulist,Graphics,textlist,DXSprite,DIB;

var
 
  ViewWidth:byte;
  ViewHeight:byte;


const
  Missions=10;
  MapSize=70;


  Tile=64;


  MaxGuns=20;
  MaxArmors=5;
  MaxMiscs=5;

type



  Tstr20=array[0..20]of char;
  Tstr40=array[0..40]of char;

  TboolLayer=array[1..MapSize,1..MapSize] of boolean;

  //  TLayer=array[1..MapSize,1..MapSize]of byte;

  TOrient=(S,SV,V,JV,J,JZ,Z,SZ);

  TGameMode=(gmsingle,gmsplit);


  it=integer;

  TData=record
           NGImages,
	   ComImages,
	   IGImages,
           Agents
                   :TDXImageList;

           Base,
           Guns,
           Faces
                 :TDXImageList;

           ComWaves,
           IGSounds
                   :TDXWaveList;
           MenuList:TMenuList;
           ComTexts:TTextList;
	   MapList:TMapList;

	 end;




    TGameState=(gsMainMenu,gsChooseMise,gsStory,gsLoadGame,gsNewGame,gsInfo,gsQuit,gsIngame,gsloading);

    TInGameState=(isBrief,isMain,isEquip,isLab,isGame,isOpt);

    TLoadData=(ldCommon,ldMainMenu,ldInGame);

    TGameStyle=(gsMise,gskampan,gsLoad);

    TCamp=array[1..Missions]of string;

    TStartPack=record
		Style:TGameStyle;
                LoadID:byte;
	       end;


     TFireTypes=(straight,wave);

     TExplosionTypes=(small,medium,large,nuke);

      TArm=record
        Name:Tstr40;
        FType:TFireTypes;
        ResCost:integer;
        EType:TExplosionTypes;
        ID:integer;
        Power:integer;
        Cost:integer;
        Cad:integer;
        Counter:integer;
        BSpeed:integer;

       end;

  TboolArms=array[1..MaxGuns]of boolean;

  TArms=array[0..maxGuns]of TArm;

  TArsenal=record
            Have:TboolArms;
            Guns:TArms;
           end;

  TArmor=record
           Name:string;
           ID:integer;
           ResCost:integer;
           Quality:integer;
           Cost:integer;
         end;

   TArmors=array[0..maxarmors]of TArmor;


procedure DrawLabel(Draw:TDXDraw;X,Y:integer;Text:string;FN:string;Color:TColor;Size:integer);
procedure DrawBitLabel(Draw:TDXDraw;R:TREct;Text:string;Image:TPictureCollectionItem;FN:string;Color:TColor;Size:word);

const
  VersionInfo='The Game v0.3-Nov2000';
  Scr:TRECT=(Left:0;Top:0;Right:640;Bottom:480);

  FontN='StarTrekGen HV BT';

  CKampan:TCamp=('C1','C2','C3','C4','C5','C6','C7',
    'C8','C9','C10');


  Guns:TArms=(
          (Name:'nil';FType:straight;
         ResCost:0;EType:small;ID:0;Power:0;Cost:0;Cad:0;Counter:0;BSpeed:0),



          (Name:'Standartn ML10 Laser';FType:straight;
         ResCost:10;  EType:small;ID:1;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'ML12 Laser';FType:straight;
         ResCost:120;  EType:small;ID:2;Power:16;Cost:550;Cad:5;Counter:0;BSpeed:2),

           (Name:'Blaster BR11';FType:straight;
         ResCost:400;  EType:small;ID:3;Power:11;Cost:850;Cad:10;Counter:0;BSpeed:3),

           (Name:'Pchotn Grantomet';FType:straight;
         ResCost:550;  EType:medium;ID:4;Power:30;Cost:1350;Cad:2;Counter:0;BSpeed:1),

           (Name:'MW10 Laser';FType:wave;
         ResCost:600;  EType:small;ID:5;Power:10;Cost:700;Cad:5;Counter:0;BSpeed:2),

           (Name:'Cizck Pistole';FType:straight;
          ResCost:400; EType:small;ID:6;Power:13;Cost:600;Cad:6;Counter:0;BSpeed:3),

           (Name:'HRott04 Pulzn Puka';FType:straight;
          ResCost:1000; EType:medium;ID:7;Power:25;Cost:1750;Cad:4;Counter:0;BSpeed:3),

           (Name:'Pchotn Raketomet';FType:straight;
          ResCost:1450; EType:large;ID:8;Power:45;Cost:2600;Cad:1;Counter:0;BSpeed:1),

           (Name:'Cizck Puka';FType:straight;
          ResCost:1000; EType:medium;ID:9;Power:26;Cost:1450;Cad:6;Counter:0;BSpeed:3),

           (Name:'HRott04 Vlnov Puka';FType:wave;
          ResCost:2000; EType:medium;ID:10;Power:25;Cost:3500;Cad:4;Counter:0;BSpeed:3),

            (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:11;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

             (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:12;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:13;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:14;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:15;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:16;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:17;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:18;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:19;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2),

           (Name:'Standartn ML10 Laser';FType:straight;
          ResCost:0; EType:small;ID:20;Power:10;Cost:350;Cad:5;Counter:0;BSpeed:2)

            );


  Armors:TArmors=(
             (Name:'nil';ID:0;
             ResCost:0; Quality:0;Cost:0),

             (Name:'Standartn Uniforma';ID:1;
              ResCost:10;Quality:5;Cost:600),

               (Name:'Kevlarov Vesta';ID:2;
             ResCost:120; Quality:12;Cost:1300),

             (Name:'Cizck Panc';ID:3;
              ResCost:800;Quality:20;Cost:2000),

              (Name:'Standartn Uniforma';ID:4;
             ResCost:1500; Quality:31;Cost:3600),

               (Name:'Bojov Oblek';ID:5;
              ResCost:10000;Quality:85;Cost:15000)
               );




// Enemy IDS   ///
idsrobot=10;
idfrobot=15;



implementation

procedure DrawLabel(Draw:TDXDraw;X,Y:integer;Text:string;FN:string;Color:TColor;Size:integer);
 begin
  with Draw.Surface.Canvas do
   begin
    Font.Name:=FN;
    Font.Color:=Color;
    Font.Size:=Size;
    Font.Style:=[fsBold];
    SetBkMode(Handle,Transparent);
    TextOut(X,Y,Text);
    Release;
   end;
 end;

procedure DrawBitLabel(Draw:TDXDraw;R:TREct;Text:string;Image:TPictureCollectionItem;FN:string;Color:Tcolor;Size:word);
  var Ext:it;

 begin
   with Draw.Surface.Canvas do
    begin
    StretchDraw(R,Image.Picture.Graphic);
    Font.Name:=FN;
    Font.Color:=Color;
    Font.Size:=Size;
    Font.Style:=[fsBold];
    SetBkMode(Handle,Transparent);
    Ext:=((R.Bottom-R.Top)-TextHeight(Text))div 2;
    inc(r.Top,ext);
    Ext:=((R.right-R.left)-TextWidth(Text))div 2;
    inc(r.left,ext);
    textout(r.left,r.top,text);
    Release;
   end;
 
 end;

function Fon(F:TFont;Name:string;Col:TColor;Size:Integer):TFont;
 begin
  Result:=F;
  Result.name:=Name;
  result.Color:=Col;
  result.Size:=Size;
 end;

 end.











